// ----------------------------------------------------------------------------
//
// FishFaD4.PAS/DFM : DCU                             Ulrich Mller     14.1.00
//                                                    Version 4.20 Delphi 32bit
//                angepasst an Delphi2-Kompatibilitt von Pascl Bihler 11.6.01
// Klasse FishFace mit integriertem FishPanel (Basis umFish.DLL)
//
// Anwahl Interface ber die Portnamen COM1-9 und LPT1-3
//               LPT  : in Registry eingetragene Adresse
// der direkte Zugriff auf das Interface geschieht ber umFish.DLL v1.3.5
//
// ----------------------------------------------------------------------------


unit FishFaD4;

//Ein bischen Versionsspionage:      (Sieht Komplex aus, vereinfacht nachher aber viel)
{$IFNDEF Win32}
   Die Bibliothek ist erst ab Delphi 2.0 nutzbar!
   You need at least Delphi 2.0 to use this library!
{$ELSE}
   {$DEFINE Delphi4+} //Standard: Delphi4 und besser
   {$IFDEF Ver90} //Delphi 2
     {$UNDEF Delphi4+}
   {$ELSE}
     {$IFDEF Ver100} //Delphi 3 (kann noch keine optionalen Parameter)
       {$UNDEF Delphi4+}
     {$ENDIF}
   {$ENDIF}
{$ENDIF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OleCtrls;

const
  ftiAus=0; ftiEin=1; ftiLinks=1; ftiRechts=2;
  ftiOff=0; ftiOn=1;  ftiLeft=1; ftiRight=2;   //Some Constants for our foreign friends
  ftiFehler=$0001FFFF; vbTrue=$FFFFFFFF; vbFalse=0;
  ftiError=$0001FFFF;

type

   OldInt = Integer;  //Da wir bei Delphi 2.0 den Integer umbenennen...


{$IFNDEF Delphi4+}    //Delphi 2.0/3.0
   Integer = LongInt;
   Cardinal = 0..2147483647;
   LongWord = Cardinal;
{$ENDIF}

  TftiDCB = record
  hCom: LongWord;
  PortID: LongWord;
  LPTDelay: LongWord;
  LPTAnalog: LongWord;
  InputStatus: LongWord;
  MotorStatus: LongWord;
  end;
  TpftiDCB = ^TftiDCB;

  TFishFace = class;
  TInputImpuls = procedure(Sender: TFishFace;
                           InputNr, ImpulsNr: LongInt) of object;
  TInterfaceStatus = procedure(Sender: TFishFace;
                               Status: LongInt) of object;
  TPositionChange = procedure(Sender: TFishFace) of object;

// --------------------- Interface Panel ----------------------------------

  TfrmPanel = class(TForm)
    cmdAction: TButton;
    cmdReset: TButton;
    cmdSchliessen: TButton;
    shpReady: TShape;
    lblPortName: TLabel;
    tmrI: TTimer;
    lblEHex: TLabel;
    lblAHex: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblAnalogX: TLabel;
    lblAnalogY: TLabel;
    lblMotor8: TLabel;
    lblMotor7: TLabel;
    lblMotor6: TLabel;
    lblMotor5: TLabel;
    lblMotor4: TLabel;
    lblMotor3: TLabel;
    lblMotor2: TLabel;
    lblMotor1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    panEingabe: TPanel;
    panAusgabe: TPanel;
    lblEingabe16: TLabel;
    lblEingabe15: TLabel;
    lblEingabe14: TLabel;
    lblEingabe13: TLabel;
    lblEingabe12: TLabel;
    lblEingabe11: TLabel;
    lblEingabe10: TLabel;
    lblEingabe09: TLabel;
    lblEingabe08: TLabel;
    lblEingabe06: TLabel;
    lblEingabe05: TLabel;
    lblEingabe04: TLabel;
    lblEingabe07: TLabel;
    lblEingabe03: TLabel;
    lblEingabe02: TLabel;
    lblEingabe01: TLabel;
    lblDreh16: TLabel;
    lblDreh15: TLabel;
    lblDreh14: TLabel;
    lblDreh13: TLabel;
    lblDreh12: TLabel;
    lblDreh11: TLabel;
    lblDreh10: TLabel;
    lblDreh09: TLabel;
    lblDreh08: TLabel;
    lblDreh07: TLabel;
    lblDreh06: TLabel;
    lblDreh05: TLabel;
    lblDreh04: TLabel;
    lblDreh03: TLabel;
    lblDreh02: TLabel;
    lblDreh01: TLabel;
    procedure cmdResetClick(Sender: TObject);
    procedure cmdActionClick(Sender: TObject);
    procedure lblDrehDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure lblDrehUp(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure lblMotorClick(Sender: TObject);
    procedure tmrITimer(Sender: TObject);
    procedure cmdSchliessenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    MotorDauer:   array[1..8] of Boolean;
    AusgabeLabel: array[1..16] of TLabel;
    EingabeLabel: array[1..16] of TLabel;
    NotStatus:    LongInt;
    Vater:        TFishFace;
    procedure MotorAusS(Mnr: Integer);
  public
  end;

// ------------------ MotListe ------------------------------------------

  TMot = record
    Ende:        Cardinal;
    EndPosition: Integer;
    Impuls:      Cardinal;
    Name:        string;
    Nr:          Cardinal;
    Position:    Integer;
  end;

  TMotListe = class(TObject)
  private
    MotorTab: array[0..7] of TMot;
    function  GetCard(i: Cardinal; Index: OldInt): Cardinal;
    procedure SetCard(i: Cardinal; Index: OldInt; Wert: Cardinal);
    function  GetInt(i: Cardinal;  Index: OldInt): Integer;
    procedure SetInt(i: Cardinal;  Index: OldInt; Wert: Integer);
    function  GetName(i: Cardinal; Index: OldInt): string;
    procedure SetName(i: Cardinal; Index: OldInt; Wert: string);
  public
    property Ende[i:Cardinal]: Cardinal index 1 read GetCard write SetCard;
    property EndPosition[i:Cardinal]: Integer index 2
                        read GetInt write SetInt;
    property Impuls[i:Cardinal]: Cardinal index 3
             read GetCard write SetCard;
    property Name[i:Cardinal]: string index 4 read GetName write SetName;
    property Nr[i:Cardinal]: Cardinal index 5 read GetCard write SetCard;
    property Position[i:Cardinal]: Integer index 6
             read GetInt write SetInt;
    constructor Create;
  end;

// ------------------ FishFace --------------------------------------------

  TFishFace = class(TObject)
  private
    PName:        string;                    // --- PortName
                                             //     '' = nicht geffnet
    ftiDCB: TftiDCB; pftiDCB: TpftiDCB;      // --- umFish ControlBlock

    MitEvents:    Boolean;                   // --- mit ProcessMessages
    AnzeigePanel: Boolean;                   // --- InterfacePanel aktiv
    Abbruchzeit:  DWORD;                     // --- Abbruchzeit in MoveTo
    AnalogXY:     array[0..1] of Cardinal;   // --- aktuelle Analogwerte
    bNotHalt:     Boolean;                   // --- Anforderung NotHalt
    bResetButton: Boolean;                   // --- Anforderung Reset
    NotStatus:    LongWord;                  // --- Motorstatus vor NotHalt
    frmPanel:     TfrmPanel;                 // --- InterfacePanel


    FOnInputImpuls:     TInputImpuls;        // --- Eventroutinen
    FOnInterfaceStatus: TInterfaceStatus;
    FOnPositionChange:  TPositionChange;

    function  SetStatus(StatusWord: LongWord;
                         MotorNr, Direction: Cardinal): LongWord;
    function  GetAnalogWert(Nr: Cardinal): LongWord;
  public
    MotCntl: TMotListe;
    property PortName: string read PName;
    property LPTDelay: Cardinal  read ftiDCB.LPTDelay write ftiDCB.LPTDelay;
    property LPTIOADR: Cardinal read ftiDCB.PortID write ftiDCB.PortID;
    property LPTAnalog: Cardinal read ftiDCB.LPTAnalog write ftiDCB.LPTAnalog;
    property InterruptEnabled: Boolean read MitEvents write MitEvents;
    property PanelEnabled: Boolean read AnzeigePanel write AnzeigePanel;
    property NotHalt: Boolean read bNotHalt write bNotHalt;
    property Reset: Boolean read bResetButton write bResetButton;
    property StatusAnalog[Nr:Cardinal]: LongWord read GetAnalogWert;
    property StatusInputs: LongWord read ftiDCB.InputStatus;
    property StatusOutputs: LongWord
             read ftiDCB.MotorStatus write ftiDCB.MotorStatus;

    property OnInputImpuls: TInputImpuls
                           read FOnInputImpuls write FOnInputImpuls;
    property OnInterfaceStatus: TInterfaceStatus
                           read FOnInterfaceStatus write FOnInterfaceStatus;
    property OnPositionChange: TPositionChange
                           read FOnPositionChange write FOnPositionChange;
  {$IFNDEF Delphi4+}
    function OpenInterface(PortName: string; MitPanel: TForm;
                           MEvents: Boolean): LongWord;
  {$ELSE}
    function OpenInterface(PortName: string; MitPanel: TForm = nil;
                           MEvents: Boolean=True): LongWord;
  {$ENDIF}

    function  CloseInterface: LongWord;

  {$IFNDEF Delphi4+}
    procedure ShowPanel(Links: Cardinal; Oben: Cardinal);
  {$ELSE}
    procedure ShowPanel(Links: Cardinal=300; Oben: Cardinal=300);
  {$ENDIF}
    procedure UnloadPanel;
    function  Version: String;

    function  GetInput(InputNr: Cardinal): Boolean;
    function  GetInputs: LongWord;
    function  GetAnalog(AnalogNr: Cardinal): LongWord;
    function  ClearMotors: LongWord;
    function  ResetMotors(InputNr: Cardinal): Boolean;
    function  EmergencyStop(InputNr: Cardinal): LongWord;
    function  SetMotors(StatusWort:Cardinal): LongWord;
    function  SetMotor(MotorNr, Direction: Cardinal): LongWord;

{$IFNDEF Delphi4+}
    function  SetMotorList(D1:Cardinal; D2:Cardinal; D3:Cardinal;
                          D4:Cardinal; D5:Cardinal; D6:Cardinal;
                          D7:Cardinal; D8: Cardinal): LongWord;
{$ELSE}
    function  SetMotorList(D1:Cardinal=9; D2:Cardinal=9; D3:Cardinal=9;
                          D4:Cardinal=9; D5:Cardinal=9; D6:Cardinal=9;
                          D7:Cardinal=9; D8: Cardinal=9): LongWord;
{$ENDIF}

    function  SetLamp(LampNr, OnOff: Cardinal):LongWord;

{$IFNDEF Delphi4+}
    function  WaitForInput(InputNr: LongWord; OnOff: Boolean):LongWord;
    function  WaitForChange(InputNr: Cardinal; NrOfChanges: Cardinal;
                           TermInputNr: Cardinal): LongWord;
{$ELSE}
    function  WaitForInput(InputNr: LongWord; OnOff: Boolean = true):LongWord;
    function  WaitForChange(InputNr: Cardinal; NrOfChanges: Cardinal=1;
                           TermInputNr: Cardinal=0): LongWord;
{$ENDIF}

    function  WaitForLow(InputNr: Cardinal): LongWord;
    procedure WaitForTime(mSec: Cardinal);

{$IFNDEF Delphi4+}
    function  MoveDelta(P1,P2,P3,P4,P5,P6,P7,P8:Integer): LongWord;
    function  MoveTo(P1,P2,P3,P4,P5,P6,P7,P8:Integer): LongWord;
{$ELSE}
    function  MoveDelta(P1:Integer=$FFFF; P2:Integer=$FFFF; P3:Integer=$FFFF;
                        P4:Integer=$FFFF; P5:Integer=$FFFF; P6:Integer=$FFFF;
                        P7:Integer=$FFFF; P8: Integer=$FFFF): LongWord;
    function  MoveTo(P1:Integer=$FFFF; P2:Integer=$FFFF; P3:Integer=$FFFF;
                     P4:Integer=$FFFF; P5:Integer=$FFFF; P6:Integer=$FFFF;
                     P7:Integer=$FFFF; P8: Integer=$FFFF): LongWord;
{$ENDIF}
    function  MoveHome: LongWord;

    constructor Create;
    destructor  Destroy; override;
  end;


implementation

{$R *.DFM}

const
  cFarbeAus = clBtnFace; cFarbeAusH = $00E0E0E0;
  cFarbeEin = $0000FF00; cFarbeFehler = $00000FF8;

var
  MotorAus: array[1..8] of LongWord  =     ($FFFC, $FFF3, $FFCF, $FF3F,
                                            $FCFF, $F3FF, $CFFF, $3FFF);
  MotorLinks: array[1..8] of LongWord  =   ($1,    $4,    $10,   $40,
                                            $100,  $400,  $1000, $4000);
  MotorRechts: array[1..8] of LongWord  =  ($2,    $8,    $20,   $80,
                                            $200,  $800,  $2000, $8000);
  EingabeMaske: array[1..16] of LongWord = ($1, $2, $4, $8, $10, $20, $40, $80,
                          $100, $200, $400, $800, $1000, $2000, $4000, $8000);
  AbbruchDelta: Cardinal = 800;
  Bremsweg: Integer = 3;

// --- umFish.DLL Deklarationen ---------------------------------

function umOpenInterface(ft: TpftiDCB; PortName: string):LongWord;
         stdcall; external 'umFish.dll' name 'OpenInterface';
function umCloseInterface(ft: TpftiDCB):LongWord;
         stdcall; external 'umFish.dll' name 'CloseInterface';
function umGetInput(ft: TpftiDCB; InputNr:LongInt):Longword;
         stdcall; external 'umFish.dll' name 'GetInput';
function umGetInputs(ft: TpftiDCB):LongWord;
         stdcall; external 'umFish.dll' name'GetInputs';
function umClearMotors(ft: TpftiDCB):LongWord;
         stdcall; external 'umFish.dll 'name'ClearMotors';
function umSetMotors(ft: TpftiDCB):LongWord;
         stdcall; external 'umFish.dll' name 'SetMotors';
function umSetMotor(ft: TpftiDCB; MotorNr, Direction:Cardinal):LongWord;
         stdcall; external 'umFish.dll' name 'SetMotor';
function umSetLamp(ft: TpftiDCB; LampNr, OnOff:Cardinal):LongWord;
         stdcall; external 'umFish.dll' name 'SetLamp';
function umGetAnalog(ft: TpftiDCB; AnalogNr:Cardinal):LongWord;
         stdcall; external 'umFish.dll' name 'GetAnalog';
function StartDriver:LongWord; stdcall; external 'umFish.dll';
function StopDriver:LongWord; stdcall; external 'umFish.dll';

// --- Allgemeine Unterprogramme -------------------------------------------

constructor TFishFace.Create;
// Create --------------------------------------------------------------------

begin
  inherited Create;
  pftiDCB  := @ftiDCB;
  MotCntl  := TMotListe.Create;
end;

destructor TFishFace.Destroy;
begin
  if ftiDCB.hCom <> 0 then CloseInterface;
  inherited Destroy;
end;

function  TFishFace.SetStatus(StatusWord: LongWord;
                            MotorNr, Direction: Cardinal): LongWord;
// --- Setzen des MotorStatus in StatusWord, kein Schalten des Motors ---

var s: LongWord;

begin
  s := StatusWord AND MotorAus[MotorNr];
  case Direction of
  ftiLinks:  s := s OR MotorLinks[MotorNr];
  ftiRechts: s := s OR MotorRechts[MotorNr];
  ftiAus:    ;
  else
    s := 0;
  end;
  SetStatus := s;
end;


function  TFishFace.GetAnalogWert(Nr: Cardinal): LongWord;
// --- GetAnalogWert (property StatusAnalog) -------------
begin
  GetAnalogWert := AnalogXY[Nr];
end;

// ---FishFace-Proceduren ------------------------------------------------------

// OpenInterface -------------------------------------------------------------
//
// Setzen Ausgangswerte, Open Schnittstelle
//
// ---------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function TFishFace.OpenInterface(PortName: string;
                               MitPanel: TForm;
                               MEvents: Boolean):LongWord;
{$ELSE}
function TFishFace.OpenInterface(PortName: string;
                               MitPanel: TForm = nil;
                               MEvents: Boolean=true):LongWord;
{$ENDIF}

var res: LongWord;
begin
  MitEvents := MEvents;
  PName := Copy(UpperCase(PortName),1,4);  // --- Gro, 4 Stellen
  bNotHalt := false;
  AnzeigePanel := false;

  if Copy(PName,1,3) = 'COM' then begin    // --- um differenzieren zu
                                           //     knnen
    Bremsweg := 3;
    res := umOpenInterface(pftiDCB, PName);
    end
  else begin
    Bremsweg := 3;
    res := umOpenInterface(pftiDCB, PName);
    end;
// --- Anzeige InterfacePanel -----------
  if (MitPanel <> nil) AND (res <> ftiFehler) then begin
    frmPanel       := TfrmPanel.Create(MitPanel);
    frmPanel.Vater := Self;
    frmPanel.Left  := MitPanel.Left+20;
    frmPanel.Top   := MitPanel.Top+20;
    frmPanel.Show;
    AnzeigePanel := True;
    end;
  Result := res;
end;

// CloseInterface ------------------------------------------------------------
//
// Schlieen der Schnittstelle
//
// ---------------------------------------------------------------------------
function TFishFace.CloseInterface: LongWord;

begin
  frmPanel.Free;
  Result := umCloseInterface(pftiDCB);
  PName := '';
end;

// ShowPanel ----------------------------------------------------------------
//
// Anzeige des Interface Panels
//
// --------------------------------------------------------------------------
{$IFNDEF Delphi4+}        
procedure TFishFace.ShowPanel(Links: Cardinal; Oben: Cardinal);
{$ELSE}
procedure TFishFace.ShowPanel(Links: Cardinal=300; Oben: Cardinal=300);
{$ENDIF}
begin
  frmPanel         := TfrmPanel.Create(Application.MainForm);
  frmPanel.Vater   := Self;
  frmPanel.Left    := Links;
  frmPanel.Top     := Oben;
  frmPanel.Show;
  AnzeigePanel     := True;
end;

// UnloadPanel ---------------------------------------------------------------
//
// Entladen des InterfacePanels
//
// ---------------------------------------------------------------------------
procedure TFishFace.UnloadPanel;
begin
  frmPanel.Free;
  AnzeigePanel := False;
  Application.ProcessMessages;
end;

// Version -------------------------------------------------------------------
//
// Ausgabe der eigenen Versionsbezeichnung
//
// 1 = P|S         : Parallel/Seriell
// 2 = V|D         : Visual Basic/ Delphi
// 3 = 1|2|3|4|5|6 : Sprachversion
// 4 = 16|32       : Wortbreite
// 6 = 130|311     : FishFace-Version
//
// ---------------------------------------------------------------------------
function  TFishFace.Version: String;
begin
  if Copy(PName,1,1) = 'C' then Version := 'SD232420' else Version := 'PD232420';
end;

// GetInput ------------------------------------------------------------------
//
// Lesen des Digitaleinganges InputNr, Refresh Motorstatus
//
// ---------------------------------------------------------------------------
function TFishFace.GetInput(InputNr: Cardinal): Boolean;

var res: LongWord;

begin
  res := GetInputs;
  if (res AND EingabeMaske[InputNr])>0 then Result := true
  else Result := false;
end;

// GetInputs -----------------------------------------------------------------
//
// Setzen Motorstatus, Lesen Inputstatus
//
// ---------------------------------------------------------------------------
function TFishFace.GetInputs: Longword;

var res: LongWord;

begin
  res := umGetInputs(pftiDCB);
  if (ftiDCB.PortID = 0) AND (res <> ftiFehler) then res := res AND $FF;
  ftiDCB.InputStatus := res;    // --- COM-Korrektur
  Result := res;
  if MitEvents then Application.ProcessMessages;
  if Assigned(FOnInterfaceStatus) then FOnInterfaceStatus(Self,Result);

end;

// GetAnalog -----------------------------------------------------------------
//
// Abfrage eines der beiden Analogeingnge
//
// ---------------------------------------------------------------------------
function TFishFace.GetAnalog(AnalogNr: Cardinal): LongWord;

var res: LongWord;

begin
  res := umGetAnalog(pftiDCB, AnalogNr);
  AnalogXY[AnalogNr] := res;
  Result := res;
  if MitEvents then Application.ProcessMessages;
end;

// ClearMotors ----------------------------------------------------------------
//
// Lschen aller (Motor)Ausgnge
//
// ----------------------------------------------------------------------------
function TFishFace.ClearMotors: LongWord;
begin
  ftiDCB.MotorStatus := 0;
  Result      := GetInputs;
end;

// ResetMotors ----------------------------------------------------------------
//
// Ausschalten der Motorausgnge, wenn InputNr oder ResetButton
//
// ----------------------------------------------------------------------------
function  TFishFace.ResetMotors(InputNr: Cardinal): Boolean;
begin
  if GetInput(InputNr) OR bResetButton
                       OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then
    begin
    ClearMotors;
    Result := true;
    end
  else
    Result := false;
end;

// EmergencyStop -------------------------------------------------------------
//
// Ausschalten der Motorausgnge, Warten auf Ende NotHalt
// Fortsetzen mit altem Motorstatus
//
// ---------------------------------------------------------------------------
function TFishFace.EmergencyStop(InputNr: Cardinal): LongWord;

var res: LongWord;

begin
  res := GetInputs;
  if bNotHalt OR ((res AND EingabeMaske[InputNr]) > 0)
              OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then begin
    NotStatus := ftiDCB.MotorStatus;
    ClearMotors;
    while bNotHalt OR ((res AND EingabeMaske[InputNr]) > 0) do res := GetInputs;
    bNotHalt := false;
    res := SetMotors(NotStatus);
    NotStatus := 0;
    end;
  EmergencyStop := res;
end;

// SetMotors ------------------------------------------------------------------
//
// Setzen aller (Motor)Ausgnge
//
// ----------------------------------------------------------------------------
function TFishFace.SetMotors(StatusWort: LongWord): LongWord;

begin
  ftiDCB.MotorStatus := StatusWort;
  Result := GetInputs;
end;

// SetMotor ------------------------------------------------------------------
//
// Schalten des (Motor)Ausganges MotorNr
//
// ---------------------------------------------------------------------------
function TFishFace.SetMotor(MotorNr, Direction: Cardinal): LongWord;

var res: LongWord;

begin
  res := umSetMotor(pftiDCB, MotorNr, Direction);
  Result := res;
  if MitEvents then Application.ProcessMessages;
  if Assigned(FOnInterfaceStatus) then FOnInterfaceStatus(Self, Result);
end;

// SetMotorList --------------------------------------------------------------
//
// Setzen ausgewhlter Motoren
//
// ---------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function TFishFace.SetMotorList(D1,D2,D3,D4,D5,D6,D7,D8:Cardinal): LongWord;
{$ELSE}                
function TFishFace.SetMotorList(D1:Cardinal=9; D2:Cardinal=9; D3:Cardinal=9;
                              D4:Cardinal=9; D5:Cardinal=9; D6:Cardinal=9;
                              D7:Cardinal=9; D8: Cardinal=9): LongWord;
{$ENDIF}

var StatusWord: LongWord;

begin
  StatusWord   := ftiDCB.MotorStatus;
  if D1 <> 9 then StatusWord := SetStatus(StatusWord, 1, D1);
  if D2 <> 9 then StatusWord := SetStatus(StatusWord, 2, D2);
  if D3 <> 9 then StatusWord := SetStatus(StatusWord, 3, D3);
  if D4 <> 9 then StatusWord := SetStatus(StatusWord, 4, D4);
  if D5 <> 9 then StatusWord := SetStatus(StatusWord, 5, D5);
  if D6 <> 9 then StatusWord := SetStatus(StatusWord, 6, D6);
  if D7 <> 9 then StatusWord := SetStatus(StatusWord, 7, D7);
  if D8 <> 9 then StatusWord := SetStatus(StatusWord, 8, D8);
  ftiDCB.MotorStatus  := StatusWord;
  Result := GetInputs;
end;

// SetLamp -----------------------------------------------------------
//
//  Schalten eines "halben" Ausganges (Lampe, Magnet)
//
// --------------------------------------------------------------------------
function TFishFace.SetLamp(LampNr, OnOff: Cardinal): LongWord;
begin
  Result := umSetLamp(pftiDCB, LampNr, OnOff);
end;

// WaitForInput -----------------------------------------------------------
//
//  Warten bis Eingang = OnOff wird. Abbruch bei NotHalt, Escape
//
// --------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function TFishFace.WaitForInput(InputNr: LongWord;
  OnOff: Boolean): LongWord;
{$ELSE}
function TFishFace.WaitForInput(InputNr: LongWord;
  OnOff: Boolean=true): LongWord;
{$ENDIF}
begin
  repeat
    Application.ProcessMessages;       // --- Unterbrechbarkeit
    if NotHalt OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then
    begin                              // --- Abbrechbarkeit
      Result := ftiFehler;
      exit;
    end;
  until (umGetInput(pftiDCB, InputNr) = vbTrue) = OnOff;
  Result := ftiDCB.InputStatus;
end;

// WaitForChange -----------------------------------------------------------
//
// Warten auf eine oder mehrere (NrOfChanges) nderungen des Status
// des Einganges InputNr oder TermInputNr = True
//
// --------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function  TFishFace.WaitForChange(InputNr: Cardinal; NrOfChanges: Cardinal;
                           TermInputNr: Cardinal): LongWord;
{$ELSE}          
function  TFishFace.WaitForChange(InputNr: Cardinal; NrOfChanges: Cardinal=1;
                           TermInputNr: Cardinal=0): LongWord;
{$ENDIF}
var
  i, res, M2, M3: LongInt; res1, res2: Boolean;
begin
  res := ftiFehler;
  M2 := EingabeMaske[InputNr];
  WaitForChange := ftiFehler;
  if TerminputNr = 0 then
    M3 := 0
  else
    begin
    M3 := EingabeMaske[TermInputNr];
    res := GetInputs;
    if (res AND M3)>0 then begin WaitForChange := res; exit end;
    end;
  res1 := (GetInputs AND M2)>0;

  for i := 1 to NrOfChanges do
    begin
    AbbruchZeit := GetTickCount + AbbruchDelta;
    repeat
      res := GetInputs;
      if res = ftiFehler then exit;
      if bNotHalt OR (GetTickCount > AbbruchZeit) then exit;
      if ((res AND M3)>0)  OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
      res2 := (res AND M2)>0;
    until res1 <> res2;
    res1 := res2;
//  ---- RaiseEvent  -----
    if Assigned(FOnInputImpuls) then FOnInputImpuls(Self, InputNr, i);
    end;
    WaitForChange := res;
end;

// WaitForLow ---------------------------------------------------------------
//
// Warten auf einen True/False Durchgang von InputNr
//
// --------------------------------------------------------------------------
function  TFishFace.WaitForLow(InputNr: Cardinal): LongWord;
var
  res, M2: LongInt; res1: Boolean;
begin
  res        := GetInputs;
  WaitForLow := res;
  M2         := EingabeMaske[InputNr];
  res1       := (ftiDCB.InputStatus AND M2)>0;

  while NOT res1 do          // --- InputNr = True herstellen
    begin
    res := GetInputs;
    if (res = ftiFehler) OR bNotHalt
                         OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
    res1 := (res AND M2)>0;
    end;

  while res1 do             // --- Wechsel auf False abwarten
    begin
    res := GetInputs;
    if (res = ftiFehler) OR bNotHalt
                         OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
    res1 := (res AND M2)>0;
    end;
  WaitForLow := res;
end;

// WaitForTime -------------------------------------------------------------
//
// Anhalten des Programmablaufs um mSec MilliSekunden
//
// -------------------------------------------------------------------------
procedure  TFishFace.WaitForTime(mSec: Cardinal);
var
  sZeit: DWORD;
begin
  sZeit := GetTickCount;
  repeat
    Application.ProcessMessages;
    GetInputs;
  until ((GetTickCount - sZeit) > mSec) OR bNotHalt
     OR (GetAsyncKeyState(VK_ESCAPE) <> 0);
end;

// MoveDelta ---------------------------------------------------------------
//
// Verfahren der Motoren um die in Pn angegebenen Strecke
//
// -------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function  TFishFace.MoveDelta(P1,P2,P3,P4,P5,P6,P7,P8:Integer): LongWord;
{$ELSE}
function  TFishFace.MoveDelta(P1: Integer=$FFFF; P2: Integer=$FFFF;
                            P3: Integer=$FFFF; P4: Integer=$FFFF;
                            P5: Integer=$FFFF; P6: Integer=$FFFF;
                            P7: Integer=$FFFF; P8: Integer=$FFFF): LongWord;
{$ENDIF}
begin
  MoveDelta := ftiFehler;
  if P8 <> $FFFF then      MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3,
                      MotCntl.Position[4] + P4, MotCntl.Position[5] + P5,
                      MotCntl.Position[6] + P6, MotCntl.Position[7] + P7,
                      MotCntl.Position[8] + P8)
  else if P7 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3,
                      MotCntl.Position[4] + P4, MotCntl.Position[5] + P5,
                      MotCntl.Position[6] + P6, MotCntl.Position[7] + P7, $FFFF)
  else if P6 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3,
                      MotCntl.Position[4] + P4, MotCntl.Position[5] + P5,
                      MotCntl.Position[6] + P6, $FFFF, $FFFF)
  else if P5 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3,
                      MotCntl.Position[4] + P4, MotCntl.Position[5] + P5, $FFFF, $FFFF, $FFFF)
  else if P4 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3,
                      MotCntl.Position[4] + P4, $FFFF, $FFFF, $FFFF, $FFFF)
  else if P3 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, MotCntl.Position[3] + P3, $FFFF, $FFFF, $FFFF, $FFFF, $FFFF)
  else if P2 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,
                      MotCntl.Position[2] + P2, $FFFF, $FFFF, $FFFF, $FFFF, $FFFF,$FFFF)
  else if P1 <> $FFFF then MoveDelta := MoveTo (MotCntl.Position[1] + P1,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF);
end;

// MoveTo ------------------------------------------------------------------
//
// Fahren der Motoren zu der in Pn angegebenen Position
// Anfahren Endtaster : "rechtsdrehend" (ftiRechts)
//
// -------------------------------------------------------------------------
{$IFNDEF Delphi4+}
function  TFishFace.MoveTo(P1,P2,P3,P4,P5,P6,P7,P8:Integer): LongWord;
{$ELSE}
function  TFishFace.MoveTo(P1: Integer=$FFFF; P2: Integer=$FFFF;
                         P3: Integer=$FFFF; P4: Integer=$FFFF;
                         P5: Integer=$FFFF; P6: Integer=$FFFF;
                         P7: Integer=$FFFF; P8: Integer=$FFFF): LongWord;
{$ENDIF}
var
  MotDreh, MotAus, MotEnde, anzMot, MotNr, i, res: LongWord;
  StatusAlt, StatusNeu, StatusDelta, MaskeEingaenge: LongWord;
  M: array[1..8] of Integer; BremsPhase: array[1..8] of Integer;
  Bremse: array[1..8] of Boolean;

begin
  MoveTo := ftiFehler;
  anzMot := 8;
  if P8 = $FFFF then Dec(anzMot) else M[8] := P8;
  if P7 = $FFFF then Dec(anzMot) else M[7] := P7;
  if P6 = $FFFF then Dec(anzMot) else M[6] := P6;
  if P5 = $FFFF then Dec(anzMot) else M[5] := P5;
  if P4 = $FFFF then Dec(anzMot) else M[4] := P4;
  if P3 = $FFFF then Dec(anzMot) else M[3] := P3;
  if P2 = $FFFF then Dec(anzMot) else M[2] := P2;
  if P1 = $FFFF then exit        else M[1] := P1;
  MaskeEingaenge := 0;
  MotDreh        := ftiDCB.MotorStatus;
  MotAus         := ftiDCB.MotorStatus;

  res       := GetInputs;
  StatusNeu := res;
// --- Fahrauftrag und Masken bestimmen -----------------------------------

  for i := 1 to anzMot do
    begin
      MotNr     := MotCntl.Nr[i];
      MotDreh   := MotDreh AND MotorAus[MotNr];  // EinzelMotor aus
      MotAus    := MotAus  AND MotorAus[MotNr];  // Alle Motoren aus
      Bremse[i] := False;

      MaskeEingaenge := MaskeEingaenge OR EingabeMaske[MotCntl.Impuls[i]]
                        OR EingabeMaske[MotCntl.Ende[i]];

    // ---- Fahrauftrag fr Einzelmotor ----

      if M[i] > MotCntl.Position[i] then        // links : weg vom Endtaster
        begin
        if M[i] >= MotCntl.EndPosition[i] then M[i] := MotCntl.EndPosition[i]
        else
          begin
          MotDreh := MotDreh OR MotorLinks[MotNr];
          BremsPhase[i] := M[i] - Bremsweg;
          end;
        end;
                                               // rechts : zum Endtaster
      if (StatusNeu AND EingabeMaske[MotCntl.Ende[i]]) > 0 then
        MotCntl.Position[i] := 0               // steht auf Endtaster
      else
        begin
        if (M[i] <= 0) AND (MotCntl.Position[i] > 0) then M[i] := -9999;
        if M[i] < MotCntl.Position[i] then
          begin
          MotDreh := MotDreh OR MotorRechts[MotNr];
          BremsPhase[i] := M[i] + Bremsweg;
          end;
        end;
    end;
  MotEnde := MotDreh;

// --- Motoren starten, Ausgangsstatus merken -----------

  StatusAlt := SetMotors(MotDreh) AND MaskeEingaenge;
  AbbruchZeit := GetTickCount + AbbruchDelta;

//
// ---- Schleife bis Fahrauftrag erledigt -----------------------
//

  while MotEnde <> MotAus do
    begin
    if bNotHalt OR (GetTickCount > AbbruchZeit)
                OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then
      begin
      res := ftiFehler;
      break;
      end;

//  --- Fahrauftrag und Status aktualisieren -----------------------------

    res := SetMotors(MotDreh);
    if res = ftiFehler then break;
    StatusNeu   := res AND MaskeEingaenge;
    StatusDelta := StatusAlt XOR StatusNeu;
    StatusAlt   := StatusNeu;

//  --- Bearbeiten der Vernderungen ---------------------------------------

    for i := 1 to anzMot do
      begin
      MotNr := MotCntl.Nr[i];
      if (MotEnde AND MotorLinks[MotNr]) > 0 then     // links : vom Taster
        begin
        if (StatusDelta AND EingabeMaske[MotCntl.Impuls[i]]) > 0 then
          begin                                      // Zhlen
          MotCntl.Position[i] := MotCntl.Position[i] + 1;
          AbbruchZeit := GetTickCount + AbbruchDelta;
          end;
        if MotCntl.Position[i] >= BremsPhase[i] then
          begin                                      // Bremsen
          if Bremse[i] then
            begin
            MotDreh := MotDreh OR MotorLinks[MotNr];
            Bremse[i] := False
            end
          else
            begin
            MotDreh := MotDreh AND MotorAus[MotNr];
            Bremse[i] := True;
            end;
          end;
        if MotCntl.Position[i] >= M[i] then
          begin                                      // Abschalten
          MotDreh := MotDreh AND MotorAus[MotNr];
          MotEnde := MotDreh;
          end;
        if MotCntl.Position[i] >= MotCntl.EndPosition[i] then
          begin                                      // Begrenzen
          MotCntl.Position[i] := MotCntl.EndPosition[i];
          MotDreh := MotDreh AND MotorAus[MotNr];
          MotEnde := MotDreh;
          end;
        end
      else if (MotEnde AND MotorRechts[MotNr]) > 0 then
        begin                                       // rechts : zum Taster
        if (StatusDelta AND EingabeMaske[MotCntl.Impuls[i]]) > 0 then
          begin
          MotCntl.Position[i] := MotCntl.Position[i] - 1;
          AbbruchZeit := GetTickCount + AbbruchDelta;
          end;
        if MotCntl.Position[i] <= BremsPhase[i] then
          if Bremse[i] then
            begin                                   // Bremsen
            MotDreh := MotDreh OR MotorRechts[MotNr];
            Bremse[i] := False;
            end
          else
            begin
            MotDreh := MotDreh AND MotorAus[MotNr];
            Bremse[i] := True;
            end;
        if MotCntl.Position[i] <= M[i] then
          begin                                     // Abschalten
          MotDreh := MotDreh AND MotorAus[MotNr];
          MotEnde := MotDreh;
          end;
        if (StatusNeu AND EingabeMaske[MotCntl.Ende[i]]) > 0 then
          begin                                     // Normieren
          MotCntl.Position[i] := 0;
          MotDreh := MotDreh AND MotorAus[MotNr];
          MotEnde := MotDreh;
          end;
        end;
      end;

// --- Raise Event ---------

      if Assigned(FOnPositionChange) then FOnPositionChange(Self);

    end;

//  --- Motoren abschalten ------------------------------------

    SetMotors(MotAus);
    if res = ftiFehler then MoveTo := ftiFehler else MoveTo := ftiDCB.InputStatus;

end;

// MoveHome ----------------------------------------------------------------
//
// Fahren der Motoren zu ihrer EndPosition
// Es werden alle Motoren angesteuert, deren Endposition < 9999(Default) ist
//
// -------------------------------------------------------------------------
function  TFishFace.MoveHome(): LongWord;
var i: Cardinal; EPos: array[1..8] of Integer;
begin
  for i := 1 to 8 do begin
    EPos[i] := $FFFF;        // --- Motor nicht vorhanden
    if MotCntl.EndPosition[i] < 9999 then EPos[i] := -9999;
  end;
  Result := MoveTo(EPos[1],EPos[2], EPos[3], EPos[4],
                   EPos[5], EPos[6], EPos[7], EPos[8]);
end;

// TMotorListe-Methoden ----------------------------------------------------
//
// Liste von simultan zu steuernden Motoren
//
// -------------------------------------------------------------------------

constructor TMotListe.Create;
var i: Cardinal;
begin
  for i := 0 to 7 do
    begin
    MotorTab[i].Ende        := i * 2 + 2;
    MotorTab[i].EndPosition := 9999;
    MotorTab[i].Impuls      := i * 2 + 1;
    MotorTab[i].Name        := 'Dummy';
    MotorTab[i].Nr          := i + 1;
    MotorTab[i].Position    := 9999;
    end;
end;

function TMotListe.GetCard(i: Cardinal; Index: OldInt): Cardinal;
begin
  with MotorTab[i-1] do
    case Index of
    1: Result := Ende;
    3: Result := Impuls;
    5: Result := Nr;
    else
      Result := $FFFF;
    end;
end;

procedure TMotListe.SetCard(i: Cardinal; Index: OldInt; Wert: Cardinal);
begin
  with MotorTab[i-1] do
    case Index of
    1: Ende        := Wert;
    3: Impuls      := Wert;
    5: Nr          := Wert;
    end;
  end;

function TMotListe.GetInt(i: Cardinal; Index: OldInt): Integer;
begin
  with MotorTab[i-1] do
    case Index of
    2: Result := EndPosition;
    6: Result := Position;
    else
      Result := $FFFF;
    end;
end;

procedure TMotListe.SetInt(i: Cardinal; Index: OldInt; Wert: Integer);
begin
  with MotorTab[i-1] do
    case Index of
    2: EndPosition := Wert;
    6: Position    := Wert;
    end;
  end;

function TMotListe.GetName(i: Cardinal; Index: OldInt): string;
begin
  GetName := MotorTab[i-1].Name;
end;

procedure TMotListe.SetName(i: Cardinal; Index: OldInt; Wert: string);
begin
  MotorTab[i-1].Name := Wert;
end;

// frmPanel-Methoden -------------------------------------------------------
//
// zum Betrieb des Interface Panels
//
// -------------------------------------------------------------------------

procedure TfrmPanel.MotorAusS(Mnr: Integer);

// ---------------- Ausschalten eines Motorausganges -----------------------

begin
  Vater.SetMotor(Mnr, ftiAus);
  AusgabeLabel[(Mnr-1)*2+1].Color := cFarbeAus;
  AusgabeLabel[(Mnr-1)*2+2].Color := cFarbeAus;
  lblAHex.Caption := IntToHex(Vater.StatusOutputs,4);
end;

procedure TfrmPanel.cmdActionClick(Sender: TObject);
// -------------- Anhalten aller Ausgnge -----------------------------------
begin
  if cmdAction.Caption = 'STOP' then
    begin
    NotStatus := Vater.StatusOutputs;
    Vater.ClearMotors;
    cmdAction.Caption := 'CONTINUE';
    end
  else
    begin
    Vater.SetMotors(NotStatus);
    NotStatus := 0;
    cmdAction.Caption := 'STOP';
    end;

end;

procedure TfrmPanel.cmdResetClick(Sender: TObject);
// --- Rcksetzen aller Motorausgnge -----------------------------------
begin
  Vater.ClearMotors;
end;

procedure TfrmPanel.cmdSchliessenClick(Sender: TObject);
// --- Schlieen Form ----------------------------------------------------
begin
  Vater.PanelEnabled := false;
  Application.ProcessMessages;
  Self.Close;
end;

procedure TfrmPanel.lblDrehDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- Motorausgang schalten ----------------------------------
//     solange MouseDown, wen Ctrl gedrckt : Dauer
var Index, Ri, Mnr: Integer;

begin
  with Sender as TLabel do Index := Tag;
  if (Index mod 2)= 0 then Ri := ftiRechts else Ri := ftiLinks;
  Mnr := (Index-1) div 2 + 1;
  if ssCtrl in Shift then MotorDauer[Mnr] := true;
  Vater.SetMotor(Mnr, Ri);
  with Sender as TLabel do Color := cFarbeEin;
  lblAHex.Caption := IntToHex(Vater.StatusOutputs,4);

end;

procedure TfrmPanel.lblDrehUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- Motorausgang abschalten, wenn kein Dauer ----------------------
var Index, Mnr: Integer;

begin
  with Sender as TLabel do Index := Tag;
  Mnr := (Index-1) div 2 + 1;
  if MotorDauer[Mnr] then exit;
  MotorAusS(Mnr);
end;

procedure TfrmPanel.lblMotorClick(Sender: TObject);
// --- Motorausgang abschalten, wenn Dauer -------------------------

var Index: Integer;

begin
  with Sender as TLabel do Index := Tag;
  MotorDauer[Index] := false;
  MotorAusS(Index);
end;

procedure TfrmPanel.tmrITimer(Sender: TObject);

// --- Zyklische Anzeige des Interface-Status -----------------------

var i: Cardinal; w: String;

begin
  Vater.GetInputs;
  if Vater.StatusInputs = ftiFehler then
    begin                                   // --- Status-Indikator
    shpReady.Brush.Color := cFarbeFehler;
    exit
    end
  else shpReady.Brush.Color := cFarbeEin;

  Str(Vater.GetAnalog(0):4, w);          // --- Analogwerte
  lblAnalogX.Caption := w;
  Str(Vater.GetAnalog(1):4, w);
  lblAnalogY.Caption := w;

  for i := 1 to 16 do                      // --- Ein- und Ausgabezeile
    begin
    if (Vater.StatusInputs and EingabeMaske[i])<>0 then
      EingabeLabel[i].Color := cFarbeEin
    else EingabeLabel[i].Color := cFarbeAus;
    if (Vater.StatusOutputs and EingabeMaske[i])<>0 then
      AusgabeLabel[i].Color := cFarbeEin
    else AusgabeLabel[i].Color := cFarbeAus;
    lblAHex.Caption := IntToHex(Vater.StatusOutputs, 4);
    lblEHex.Caption := IntToHex(Vater.StatusInputs, 4);
    end;
end;

procedure TfrmPanel.FormShow(Sender: TObject);
// --- Besetzen der Zuordnungstabellen fr die Label der Ein-/Ausgabezeilen
begin
  AusgabeLabel[01] := lblDreh01;
  AusgabeLabel[02] := lblDreh02;
  AusgabeLabel[03] := lblDreh03;
  AusgabeLabel[04] := lblDreh04;
  AusgabeLabel[05] := lblDreh05;
  AusgabeLabel[06] := lblDreh06;
  AusgabeLabel[07] := lblDreh07;
  AusgabeLabel[08] := lblDreh08;
  AusgabeLabel[09] := lblDreh09;
  AusgabeLabel[10] := lblDreh10;
  AusgabeLabel[11] := lblDreh11;
  AusgabeLabel[12] := lblDreh12;
  AusgabeLabel[13] := lblDreh13;
  AusgabeLabel[14] := lblDreh14;
  AusgabeLabel[15] := lblDreh15;
  AusgabeLabel[16] := lblDreh16;
  EingabeLabel[01] := lblEingabe01;
  EingabeLabel[02] := lblEingabe02;
  EingabeLabel[03] := lblEingabe03;
  EingabeLabel[04] := lblEingabe04;
  EingabeLabel[05] := lblEingabe05;
  EingabeLabel[06] := lblEingabe06;
  EingabeLabel[07] := lblEingabe07;
  EingabeLabel[08] := lblEingabe08;
  EingabeLabel[09] := lblEingabe09;
  EingabeLabel[10] := lblEingabe10;
  EingabeLabel[11] := lblEingabe11;
  EingabeLabel[12] := lblEingabe12;
  EingabeLabel[13] := lblEingabe13;
  EingabeLabel[14] := lblEingabe14;
  EingabeLabel[15] := lblEingabe15;
  EingabeLabel[16] := lblEingabe16;

  lblPortName.Caption  := Vater.PortName;
  tmrI.Enabled := true;
end;


procedure TfrmPanel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tmrI.Enabled := false;            // --- luft sonst bei Close weiter
end;

end.
