// ----------------------------------------------------------------------------
//
// frmFishPanel(FishPumD.PAS/DFM)                         Ulrich Mller 26.1.00
//                                                        Procida 400NT Delphi4
// FishPanel mit umFish.DLL
//
// Die Form kann standalone oder ber frmFishPanel.ShowPanel genutzt werden
//          im zweiten Fall mu bereits ein OpenInterface erfolgt sein.
//
// Die Label der Ein-/Ausgabezeilen haben Tags mit den Werten 1 - 16
// um eine Zuordnung Label-Interface in einer gemeinsamen Ereignis-Routine
// zu ermglichen. Fr die Zuordnung Status-Label sind alle Label in je
// einer Ein- und Ausgabe-Tabelle aufgefhrt, der Zugriff erfolgt ber
// die dort gespeicherte Tabelle
//
// ----------------------------------------------------------------------------

unit FishPumD;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, umFishEx;

type
  TfrmFishPanel = class(TForm)
    cmdAction: TButton;
    cmdReset: TButton;
    shpReady: TShape;
    lblPortName: TLabel;
    tmrI: TTimer;
    lblEHex: TLabel;
    lblAHex: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblAnalogX: TLabel;
    lblAnalogY: TLabel;
    lblMotor8: TLabel;
    lblMotor7: TLabel;
    lblMotor6: TLabel;
    lblMotor5: TLabel;
    lblMotor4: TLabel;
    lblMotor3: TLabel;
    lblMotor2: TLabel;
    lblMotor1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    panEingabe: TPanel;
    panAusgabe: TPanel;
    lblEingabe16: TLabel;
    lblEingabe15: TLabel;
    lblEingabe14: TLabel;
    lblEingabe13: TLabel;
    lblEingabe12: TLabel;
    lblEingabe11: TLabel;
    lblEingabe10: TLabel;
    lblEingabe09: TLabel;
    lblEingabe08: TLabel;
    lblEingabe06: TLabel;
    lblEingabe05: TLabel;
    lblEingabe04: TLabel;
    lblEingabe07: TLabel;
    lblEingabe03: TLabel;
    lblEingabe02: TLabel;
    lblEingabe01: TLabel;
    lblDreh16: TLabel;
    lblDreh15: TLabel;
    lblDreh14: TLabel;
    lblDreh13: TLabel;
    lblDreh12: TLabel;
    lblDreh11: TLabel;
    lblDreh10: TLabel;
    lblDreh09: TLabel;
    lblDreh08: TLabel;
    lblDreh07: TLabel;
    lblDreh06: TLabel;
    lblDreh05: TLabel;
    lblDreh04: TLabel;
    lblDreh03: TLabel;
    lblDreh02: TLabel;
    lblDreh01: TLabel;
    procedure CmdResetClick(Sender: TObject);
    procedure CmdActionClick(Sender: TObject);
    procedure ShowPanel(var ft: TftiDCB; PName: string);
    procedure lblDrehDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure lblDrehUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblMotorClick(Sender: TObject);
    procedure tmrITimer(Sender: TObject);
  private
    procedure PanelAktivieren;
  public
    { Public-Deklarationen}
  end;

var
  frmFishPanel: TfrmFishPanel;

implementation

{$R *.DFM}

const
  cFarbeAus = clBtnFace; cFarbeAusH   = $00E0E0E0;
  cFarbeEin = $0000FF00; cFarbeFehler = $00000FF8;
var
  MotorDauer:   array[1..8] of Boolean;
  EingabeMaske: array[1..16] of LongInt = ($1,    $2,    $4,    $8,
                                           $10,   $20,   $40,   $80,
                                           $100,  $200,  $400,  $800,
                                           $1000, $2000, $4000, $8000);
  PortName:     string = 'COM1';
  AusgabeLabel: array[1..16] of TLabel;
  EingabeLabel: array[1..16] of TLabel;
  ftiDCB:       TftiDCB; pftiDCB: TpftiDCB; SPanel: Boolean;

function OpenInterface(ft: TpftiDCB; PortName: string):LongInt;
       stdcall; external 'umFish.dll';
function CloseInterface(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function GetInput(ft: TpftiDCB; InputNr:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function GetInputs(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function ClearMotors(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function SetMotors(ft: TpftiDCB; MotorStatus:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetMotor(ft: TpftiDCB; MotorNr, Direction:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetLamp(ft: TpftiDCB; LampNr, OnOff:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function GetAnalog(ft: TpftiDCB; AnalogNr:LongInt):LongInt;
       stdcall; external 'umFish.dll';

// --- Allgemeine Unterprogramme -------------------------------------------

procedure MotorAusS(Mnr: Integer);
// ---------------- Ausschalten eines Motorausganges -----------------------

begin
  SetMotor(pftiDCB, Mnr, ftiAus);
  AusgabeLabel[(Mnr-1)*2+1].Color := cFarbeAus;
  AusgabeLabel[(Mnr-1)*2+2].Color := cFarbeAus;
  frmFishPanel.lblAHex.Caption := IntToHex(ftiDCB.MotorStatus,4);
end;

procedure TfrmFishPanel.PanelAktivieren;
// --- Anzeigen, Button-Steuerung ------

begin
  panAusgabe.Enabled := true;
  tmrI.Enabled := true;
  cmdAction.Caption := 'ENDE';
  cmdReset.Caption := 'RESET';
  lblPortName.Caption := PortName;
  shpReady.Brush.Color := cFarbeEin;
end;

// ------------ frmPanel-Methoden ------------------------------------------


procedure TfrmFishPanel.CmdActionClick(Sender: TObject);
// ---------- Open/CloseInterface ----------------------
//            alternativ 'ENDE'

var res: LongInt;

begin
  if cmdAction.Caption = 'START' then      // --- OpenInterface
    begin
    SPanel := false;
    if ParamStr(1) = '' then               // --- PortName im Dialog
      PortName := InputBox('FishPanel',
        'Bitte Portnamen eingeben : COM1-4 oder LPt1-3',PortName)
    else PortName := ParamStr(1);          // --- PortName von Commandline
    PortName := UpperCase(PortName);
    pftiDCB := @ftiDCB;
    res := OpenInterface(pftiDCB, PortName);
    if res = ftiFehler then                // --- bei Fehler Exit procedure
      begin
      MessageDlg('Interfaceproblem : ' + PortName,mtWarning,[mbOK],0);
      exit;
      end
    else PanelAktivieren;
    end                                    // --- CloseInterface
  else
    begin
    if NOT SPanel then CloseInterface(pftiDCB);
    Self.Close;
    end;
end;

procedure TfrmFishPanel.ShowPanel(var ft: TftiDCB; PName: string);
// --- Aufruf des InterfacePanel von einer anderen Form ----------
//     OpenInterface mu bereits erfolgt sein --------------------

begin
  ftiDCB := ft;
  pftiDCB := @ft;
  PortName := PName;
  SPanel := true;
  Self.Show;
  PanelAktivieren;
end;

procedure TfrmFishPanel.CmdResetClick(Sender: TObject);
// --- Rcksetzen aller Motorausgnge -----------------

begin
  if cmdReset.Caption = 'RESET' then
    ClearMotors(pftiDCB)
  else                     // --- wenn kein korr. Open : Abbruch Programm
    begin
    Self.Close;
    end;
end;

procedure TfrmFishPanel.lblDrehDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- Motorausgang schalten --------------------------------------------
//     solange MouseDown, wen Ctrl gedrckt : Dauer

var Index, Ri, Mnr: Integer;

begin
  with Sender as TLabel do Index := Tag;
  if (Index mod 2)= 0 then Ri := ftiRechts else Ri := ftiLinks;
  Mnr := (Index-1) div 2 + 1;
  if ssCtrl in Shift then MotorDauer[Mnr] := true;
  SetMotor(pftiDCB, Mnr, Ri);
  with Sender as TLabel do Color := cFarbeEin;
  lblAHex.Caption := IntToHex(ftiDCB.MotorStatus,4);
end;

procedure TfrmFishPanel.lblDrehUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- Motorausgang abschalten, wenn kein Dauer ----------------------

var Index, Mnr: Integer;

begin
  with Sender as TLabel do Index := Tag;
  Mnr := (Index-1) div 2 + 1;
  if MotorDauer[Mnr] then exit;
  MotorAusS(Mnr);
end;

procedure TfrmFishPanel.lblMotorClick(Sender: TObject);
// --- Motorausgang abschalten, wenn Dauer ------------

var Index: Integer;

begin
  with Sender as TLabel do Index := Tag;
  MotorDauer[Index] := false;
  MotorAusS(Index);
end;

procedure TfrmFishPanel.tmrITimer(Sender: TObject);
// --- Zyklische Anzeige des Interface-Status -----

var i: LongInt; w: String;

begin
  GetInputs(pftiDCB);
  if ftiDCB.InputStatus = ftiFehler then
    begin                                   // --- Status-Indikator
    shpReady.Brush.Color := cFarbeFehler;
    exit
    end
  else shpReady.Brush.Color := cFarbeEin;

  Str(GetAnalog(pftiDCB, 0):4, w);          // --- Analogwerte
  lblAnalogX.Caption := w;
  Str(GetAnalog(pftiDCB, 1):4, w);
  lblAnalogY.Caption := w;
  if Copy(PortName,1,1) = 'C' then          // --- umFish.DLL Patch
    begin
    ftiDCB.InputStatus := ftiDCB.InputStatus and $FF;
    ftiDCB.MotorStatus := ftiDCB.MotorStatus and $FF;
    end;

  for i := 1 to 16 do                      // --- Ein- und Ausgabezeile
    begin
    if (ftiDCB.InputStatus and EingabeMaske[i])<>0 then
      EingabeLabel[i].Color := cFarbeEin
    else EingabeLabel[i].Color := cFarbeAus;
    if (ftiDCB.MotorStatus and EingabeMaske[i])<>0 then
      AusgabeLabel[i].Color := cFarbeEin
    else AusgabeLabel[i].Color := cFarbeAus;
    lblAHex.Caption := IntToHex(ftiDCB.MotorStatus,4);
    lblEHex.Caption := IntToHex(ftiDCB.InputStatus,4);
    end;
end;

procedure TfrmFishPanel.FormShow(Sender: TObject);

// --- Besetzen der Zuordnungstabellen fr die Label der Ein-/Ausgabezeilen

begin
  AusgabeLabel[01] := lblDreh01;
  AusgabeLabel[02] := lblDreh02;
  AusgabeLabel[03] := lblDreh03;
  AusgabeLabel[04] := lblDreh04;
  AusgabeLabel[05] := lblDreh05;
  AusgabeLabel[06] := lblDreh06;
  AusgabeLabel[07] := lblDreh07;
  AusgabeLabel[08] := lblDreh08;
  AusgabeLabel[09] := lblDreh09;
  AusgabeLabel[10] := lblDreh10;
  AusgabeLabel[11] := lblDreh11;
  AusgabeLabel[12] := lblDreh12;
  AusgabeLabel[13] := lblDreh13;
  AusgabeLabel[14] := lblDreh14;
  AusgabeLabel[15] := lblDreh15;
  AusgabeLabel[16] := lblDreh16;
  EingabeLabel[01] := lblEingabe01;
  EingabeLabel[02] := lblEingabe02;
  EingabeLabel[03] := lblEingabe03;
  EingabeLabel[04] := lblEingabe04;
  EingabeLabel[05] := lblEingabe05;
  EingabeLabel[06] := lblEingabe06;
  EingabeLabel[07] := lblEingabe07;
  EingabeLabel[08] := lblEingabe08;
  EingabeLabel[09] := lblEingabe09;
  EingabeLabel[10] := lblEingabe10;
  EingabeLabel[11] := lblEingabe11;
  EingabeLabel[12] := lblEingabe12;
  EingabeLabel[13] := lblEingabe13;
  EingabeLabel[14] := lblEingabe14;
  EingabeLabel[15] := lblEingabe15;
  EingabeLabel[16] := lblEingabe16;
end;

end.
