// ---------------------------------------------------------------------------
//
// easyMain(easyMain.PAS/DFM)                            Ulrich Mller 26.1.00
//                                                       Procida 400NT Delphi4
// Rahmenprogramm fr den Betrieb eigener Delphi4-Programme
// auf Basis von umFishEx und umFish.DLL
//
// ---------------------------------------------------------------------------

unit easyMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, IniFiles;

type
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    cboPorts: TComboBox;
    shpInterface: TShape;
    tmrI: TTimer;
    lblStatus: TLabel;
    pnlStatus: TPanel;
    Shape1: TShape;
    lblM1: TLabel;
    lblM1R: TLabel;
    lblM1A: TLabel;
    lblM1L: TLabel;
    lblM2: TLabel;
    lblM2R: TLabel;
    lblM2A: TLabel;
    lblM2L: TLabel;
    lblM3: TLabel;
    lblM3R: TLabel;
    lblM3A: TLabel;
    lblM3L: TLabel;
    lblM4: TLabel;
    lblM4R: TLabel;
    lblM4A: TLabel;
    lblM4L: TLabel;
    Shape2: TShape;
    lblE1E: TLabel;
    lblE2E: TLabel;
    lblE1: TLabel;
    lblE2: TLabel;
    lblE4: TLabel;
    lblE4E: TLabel;
    lblE3E: TLabel;
    lblE3: TLabel;
    lblE6E: TLabel;
    lblE6: TLabel;
    lblE5: TLabel;
    lblE5E: TLabel;
    lblE8E: TLabel;
    lblE8: TLabel;
    lblE7: TLabel;
    lblE7E: TLabel;
    lblEXWert: TLabel;
    lblEX: TLabel;
    lblEY: TLabel;
    lblEYWert: TLabel;
    txtWert1: TEdit;
    lblWert1: TLabel;
    txtWert2: TEdit;
    lblWert2: TLabel;
    lblTitel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cboPortsClick(Sender: TObject);
    procedure tmrITimer(Sender: TObject);
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdActionClick(Sender: TObject);
    procedure lblMDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblMUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lblMClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

procedure printStatus(StatusText: string);
function Werte(Nr:Cardinal): Integer;

implementation

{$R *.DFM}

uses
  easyRun, umFishEx;

const
  cFarbeAus = clSilver; cFarbeEin = clLime;
  EMaske: array[1..8] of LongWord= ($1, $2, $4, $8, $10, $20, $40, $80);

var
  Pfad: string; INI: TIniFile; OutPutDelay: Cardinal;
  PortName: string;
  MotorDauer: array[1..4] of Boolean = (false, false, false, false);
  AusgabeLabel: array[1..8] of TLabel;
  EingabeLabel: array[1..8] of TLabel;

// ---------------- Routinen zur Nutzung aus easyRun -----------------

procedure printStatus(StatusText: string);
// --- Ausgabe von Text in das Statusfeld ---
begin
  frmMain.lblStatus.Caption := StatusText;
end;

function Werte(Nr:Cardinal): Integer;
begin
  case Nr of
  1: Result := StrToIntDef(frmMain.txtWert1.Text, 0);
  2: Result := StrToIntDef(frmMain.txtWert2.Text, 0);
  else
    Result := 0;
  end;
end;

// --- Form Procedures -----------------------------------------------

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Pfad := ExtractFilePath(Application.ExeName);
  SetCurrentDir(ExtractFileDir(Application.ExeName));

// --- INI-Daten ----------------------------------------------
  INI                := TIniFile.Create(Pfad + 'easyFish.INI');
  Self.Left          := INI.ReadInteger('Geometrie', 'Links', 0);
  Self.Top           := INI.ReadInteger('Geometrie', 'Oben', 0);
  OutputDelay        := INI.ReadInteger('Common', 'LPTDelay', 5);
  cboPorts.ItemIndex := INI.ReadInteger('Common', 'PortNo', 7);
  INI.Free;

// --- InterfacePanel -----
  AusgabeLabel[1] := lblM1L;
  AusgabeLabel[2] := lblM1R;
  AusgabeLabel[3] := lblM2L;
  AusgabeLabel[4] := lblM2R;
  AusgabeLabel[5] := lblM3L;
  AusgabeLabel[6] := lblM3R;
  AusgabeLabel[7] := lblM4L;
  AusgabeLabel[8] := lblM4R;
  EingabeLabel[1] := lblE1E;
  EingabeLabel[2] := lblE2E;
  EingabeLabel[3] := lblE3E;
  EingabeLabel[4] := lblE4E;
  EingabeLabel[5] := lblE5E;
  EingabeLabel[6] := lblE6E;
  EingabeLabel[7] := lblE7E;
  EingabeLabel[8] := lblE8E;

// --- Beschriftungen ------
  lblTitel.Caption := clblTitel;
  lblM1.Caption := clblM[1];
  lblM2.Caption := clblM[2];
  lblM3.Caption := clblM[3];
  lblM4.Caption := clblM[4];
  lblE1.Caption := clblE[1];
  lblE2.Caption := clblE[2];
  lblE3.Caption := clblE[3];
  lblE4.Caption := clblE[4];
  lblE5.Caption := clblE[5];
  lblE6.Caption := clblE[6];
  lblE7.Caption := clblE[7];
  lblE8.Caption := clblE[8];
  lblEX.Caption := clblA[1];
  lblEY.Caption := clblA[2];
  lblWert1.Caption := clblW[1];
  txtWert1.Text    := ctxtW[1];
  lblWert2.Caption := clblW[2];
  txtWert2.Text    := ctxtW[2];

  Self.Show;
  cboPortsClick(Self);                   // --- OpenInteface
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// --- Sichern INI-Daten ------------------------------------------------
  INI := TIniFile.Create(Pfad + 'easyFish.INI');
  INI.WriteString('Common',    'PortNo',   IntToStr(cboPorts.ItemIndex));
  INI.WriteString('Common',    'LPTDelay', IntToStr(OutputDelay));
  INI.WriteString('Geometrie', 'Links',    IntToStr(Self.Left));
  INI.WriteString('Geometrie', 'Oben',     IntToStr(Self.Top));
  INI.Free;

  tmrI.Enabled := false;
  ftiClearMotors;
  ftiCloseInterface;
end;

procedure TfrmMain.cboPortsClick(Sender: TObject);
// --- OpenInterface -----------------------------
begin
  tmrI.Enabled := false;
  ftiCloseInterface;
  PortName := cboPorts.Text;
  if ftiOpenInterface(PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    cmdAction.Enabled := false;
  end
  else begin
    ftiDCB.LPTDelay := OutputDelay;
    tmrI.Enabled := true;
    cmdAction.Enabled := true;
  end;
end;

procedure TfrmMain.tmrITimer(Sender: TObject);
// --- Statusanzeige des Interfaces ----------
var i:LongWord; w: string;
begin
  if ftiGetInputs = ftiFehler then begin             // --- OK-Anzeige
    shpInterface.Brush.Color := clRed;
    ftiNotHalt := true;
    exit;
  end
  else shpInterface.Brush.Color := clLime;

  Str(ftiGetAnalog(0):4, w);                       // --- Analogwerte
  lblEXWert.Caption := w;
  Str(ftiGetAnalog(1):4, w);
  lblEYWert.Caption := w;

  for i := 1 to 8 do begin
    if (ftiDCB.InputStatus AND EMaske[i]) <> 0 then     // --- E-Werte
      EingabeLabel[i].Color := cFarbeEin
    else EingabeLabel[i].Color := cFarbeAus;
    if (ftiDCB.MotorStatus AND EMaske[i]) <> 0 then     // --- M-Werte
      AusgabeLabel[i].Color := cFarbeEin
    else AusgabeLabel[i].Color := cFarbeAus;
  end;
end;

// --- Action Routinen ---------------------------------------

procedure TfrmMain.cmdEndeClick(Sender: TObject);
// --- Programm beenden -------------------------
begin
  Self.Close
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
// --- Anwendung starten / anhalten ---------------
begin
  if cmdAction.Caption = 'START' then begin
    ftiNotHalt := false;
    cmdAction.Caption := 'HALT';
    cmdEnde.Enabled := false;
    pnlStatus.Enabled := false;
    lblStatus.Caption := 'Gestartet';
    ftiClearMotors;
    fishMain;                            // --- Anwendung
  end
  else ftiNotHalt := true;
  ftiClearMotors;
  cmdAction.Caption := 'START';
  cmdEnde.Enabled := true;
  lblStatus.Caption := 'START/ENDE';
  pnlStatus.Enabled := true;
end;

// --- InterfacePanel Routinen ---------------------------------

procedure MotorAusS(Mnr: LongWord);
// --- Motoranzeige im InterfacePanel aus ----
begin
  ftiSetMotor(Mnr, ftiAus);
  AusgabeLabel[(Mnr-1)*2+1].Color := cFarbeAus;
  AusgabeLabel[(Mnr-1)*2+2].Color := cFarbeAus;
end;

procedure TfrmMain.lblMDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- Motor ein bei MouseDown -----------------------------------

var Index, Ri, Mnr: LongWord;

begin
  with Sender as TLabel do Index := Tag;
  if (Index mod 2) = 0 then Ri := ftiRechts else Ri := ftiLinks;
  Mnr := (Index-1) div 2 + 1;
  if ssCtrl in Shift then MotorDauer[Mnr] := true;
  ftiSetMotor(Mnr, Ri);
  with Sender as TLabel do Color := cFarbeEin;
end;

procedure TfrmMain.lblMUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// ---- Motor ein bei MousUp ----------------------------------

var Index, Mnr: LongWord;
begin
  with Sender as TLabel do Index := Tag;
  Mnr := (Index-1) div 2 + 1;
  if MotorDauer[Mnr] then exit;
  MotorAusS(Mnr);
end;

procedure TfrmMain.lblMClick(Sender: TObject);
// --- Motorausgang abschalten, wenn Dauer ---
var Index: LongWord;
begin
  with Sender as TLabel do Index := Tag;
  MotorDauer[Index] := false;
  MotorAusS(Index);
end;

end.
