// ---------------------------------------------------------------------------
//
// easyRun(easyRun.PAS)                                  Ulrich Mller 26.1.00
//                                                       Procida 400NT Delphi4
// Unit zur Erstellung eigener Delphi4-Programme zum Betrieb von ft-Modellen
// auf Basis von umFishEx, umFish.DLL und easyMain
// die weiteren Units mssen nicht modifiziert werden.
// es stehen die normalen Delphi4 Sprachmittel und Funktionen aus
// umFishEx und easyMain zur Verfgung.
//
// Beispiel Pneumatic Robots : Greifer
//
// ---------------------------------------------------------------------------

unit easyRun;
interface
const            // --- Beschriftung des InterfacePanels ------
  clblTitel = 'Pneumatic Robots : Greifer';
  clblE: array[1..8] of string = ('E1', 'E2', 'E3', 'E4',
                                   'E5', 'E6', 'E7', 'Reset');
  clblM: array[1..4] of string = ('Arm A', 'Arm B', 'Greifer', 'Kompressor');
  clblA: array[1..2] of string = ('EX', 'EY');
  clblW: array[1..2] of string = ('Wert A', 'Wert B');
  ctxtW: array[1..2] of string = ('0', '0');

//  ---------------- bei Bedarf an das Programm anpassen ------

procedure fishMain();
implementation
uses Windows, Messages, SysUtils, Forms, Dialogs,
     easyMain, umFishEx;

const            // --- Konstanten zum Ansprechen der InterfaceGerte ---
  cvArmA = 1; cvArmB = 2; cvGreifer = 3; cmKompressor = 4;
  ctReset = 8;

procedure ArmPosA;
// --- Arm nach Position A -----
begin
  ftiSetMotor(cvArmB, ftiAus);
  ftiSetMotor(cvArmA, ftiEin);
  if ftiGetInput(ctReset) then exit;   // --- Abbruch durch Reset
  printStatus('Position A');
  ftiWaitForTime(2000);
end;

procedure ArmPosB;
// --- Arm nach Position B -----
begin
  ftiSetMotor(cvArmA, ftiAus);
  ftiSetMotor(cvArmB, ftiEin);
  if ftiGetInput(ctReset) then exit;   // --- Abbruch durch Reset
  printStatus('Position B');
  ftiWaitForTime(2000);
end;

procedure GreiferAuf;
// --- Greifer ffnen -------------
begin
  ftiSetMotor(cvGreifer, ftiAus);
  if ftiGetInput(ctReset) then exit;   // --- Abbruch durch Reset
  printStatus('Greifer Auf');
  ftiWaitForTime(2000);
end;

procedure GreiferZu;
// ---- Greifer schlieen --------
begin
  ftiSetMotor(cvGreifer, ftiEin);
  if ftiGetInput(ctReset) then exit;   // --- Abbruch durch Reset
  printStatus('Greifer Zu');
  ftiWaitForTime(2000);
end;

procedure fishMain;  // --- Haupt Procedure, Name ist fest
                     //     Aufruf ber START-Button
                     //     Es knnen beliebige weitere procedure und
                     //     function erstellt werden.
begin
  ftiSetMotor(cmKompressor, ftiEin);    // --- Startphase
  ftiWaitForTime(3000);
  GreiferAuf;
  ArmPosA;
  printStatus('Anlage ready');

  repeat
    GreiferZu;
    ArmPosB;
    GreiferAuf;
    ArmPosA;
    ArmPosB;
    GreiferZu;
    ArmPosA;
    GreiferAuf;
    ArmPosB;
    ArmPosA;
  until ftiFinish(ctReset);
end;

end.
