// ----------------------------------------------------------------------------
//
// frmMainEx(umFishET.PAS/DFM)                           Ulrich Mller 24.1.00
//                                                       Procida 400NT Delphi4
// fischertechnik Interface : umFishEx.DCU Demo
//
// Lampen an M1 - M3 werden in einer Endloschleife an- und ausgeschaltet
// Zustzlich wird der Wert des Analogeinganges EX angezeigt.
// Beenden : HALT-Button, Taster E1 oder Escape-Taste
//
// ----------------------------------------------------------------------------

unit umFishET;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, umFishEx;

type
  TfrmMainEx = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblEx: TLabel;
    lblPortName: TLabel;
    Label4: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdActionClick(Sender: TObject);
  private
    procedure Blinken;
  public
    { Public-Deklarationen }
  end;

var
  frmMainEx: TfrmMainEx;

implementation

{$R *.DFM}

var PortName: string;

procedure TfrmMainEx.cmdEndeClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmMainEx.cmdActionClick(Sender: TObject);
// --- Start / Ende Test ----------------------------
begin
  if cmdAction.Caption = 'HALT' then begin ftiNotHalt := true; exit; end;
  PortName := InputBox('umFishEx.DCU Demo',
                       'PortName : COM1-9, LPT1-3, LPT(nur WinNT)', 'COM1');
  lblPortName.Caption := PortName;  // --- Interfaceverbindung herstellen
  if ftiOpenInterface(PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem : PortName, Strom, Kabel?',
               mtInformation, [mbOK], 0);
    exit;
    end;
  cmdAction.Caption := 'HALT';
  cmdEnde.Caption   := 'ENDE';
  cmdEnde.Enabled   := false;
  ftiNotHalt := false;
  Blinken;                         // --- Demo-Schleife
  cmdAction.Caption := 'START';
  cmdEnde.Enabled   := true;
  ftiCloseInterface;               // --- Interfaceverbindung schlieen
end;

procedure TfrmMainEx.Blinken;
// --- Demo-Schleife --------
var i: Cardinal;
begin
  i := 1;
  repeat
    ftiSetMotor(i, ftiEin);         // --- Einschalten Mi
    lblEx.Caption := IntToStr(ftiGetAnalog(0));  // --- Anzeigen EX
    ftiWaitForTime(600);            // --- Warten 600 mSek
    ftiSetMotor(i, ftiAus);         // --- Ausschalten Mi
    ftiWaitForTime(300);            // --- Warten 300 mSek
    if i>=3 then i := 1 else Inc(i);
  until ftiFinish(1);               // --- Ende durch ftiNotHalt, Escape oder E1
  ftiClearMotors;                   // --- Ausschalten aller Ausgnge
end;

end.
